class MeBot expands Mutator;

event PostBeginPlay()
{
	if ( Level.Game != None )
		Level.Game.RegisterMessageMutator(Self);
}

function Mutate(string MutateString, PlayerPawn Sender)
{
	local InvWay W;
	local bool bAbusing;
	local Actor Path;
	local float BestWeight;

	if ( MutateString ~= "mebot" )
	{
		BestWeight = 0;
		Sender.ClientMessage("Bot Mode Navigation", 'CriticalEvent', True);
		foreach Sender.ChildActors (class'InvWay',W)
		{
			if ( W != None )
			{
				bAbusing = True;
				break;
			}
		}
		if (bAbusing)
		{
			Sender.ClientMessage("Mr. Bot, Your beacon has already spawned... If you don't see it wander around and retry later...", 'CriticalEvent', True);
		}
		else
		{
			Path = Sender.FindBestInventoryPath(BestWeight,False);
			if ( Path != None )
			{
				if ( Teleporter(Path) != None && Sender.RouteCache[2] != None )
					Path = Sender.RouteCache[2];
				W = Spawn(class'InvWay',Sender,,Path.Location);
				if ( W != None )
				{
					if ( Path.Base != None )
						W.SetBase(Path.Base);
					else
						W.SetBase(None);
					Sender.ClientMessage( "Your Inventory way is shown. See the lamp and move there...", 'CriticalEvent', True );
				}
				else
					Sender.ClientMessage( "Cannot deal this time...", 'CriticalEvent', True );
			}
			else
				Sender.ClientMessage("Unable to find your Inventory way. Wander at walls then...", 'CriticalEvent', True);
		}
	}

	if ( NextMutator != None )
		NextMutator.Mutate(MutateString, Sender);
}